//
// = FILENAME
//    StupidAgent.hh
//
// = FUNCTION
//
// = AUTHOR(S)
//    Patric Jensfelt
//
// = COPYRIGHT
//    Copyright (c) 2006 Patric Jensfelt
//
/*----------------------------------------------------------------------*/

#ifndef StupidAgent_hh
#define StupidAgent_hh

#include "MineAgent.hh"

class StupidAgent : public MineAgent {
public:
  StupidAgent();
  ~StupidAgent();
  
  /**
   * @param numPlayers tells how many players are playing this game
   * @param playerID the id for this player in the game
   * @param xsize number of squares in the horizontal direction
   * @param ysize number of squares in the vertical direction 
   * @param deadCost cost to die
   * @param peekCost the cos to take a peek at a square
   * 
   * @return true if initialization went ok
   */
  bool startNewGame(int numPlayers, int playerID,
                    int xsize, int ysize,
                    int deadCost, int peekCost);
  
  /**
   * @return the move suggested by this agent given the information
   * it has gathered so far
   */
  MineMove getNextMove();

  /**
   * This function is called by the system after a square is opened,
   * another player has died or stopped playing.
   *
   * @param info information about the game
   */
  void handleInfo(MineInfo info);

protected:

  /*
   * Will free memory allocated for m_Opened
   */
  void freeMemory();

protected:
  char *m_Opened;
  int m_XSize;
  int m_YSize;
  bool m_TryPeeking;
};

#endif // StupidAgent_hh
